Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Pentax.pm	(revision 34921)
@@ -4271,5 +5744,5 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     FIRST_ENTRY => 0,
-    NOTES => 'This information is found in Pentax MOV videos.',
+    NOTES => 'This information is found in MOV videos from cameras such as the Optio WP.',
     0x00 => {
         Name => 'Make',
@@ -4326,6 +5799,26 @@
             Start => 10,
             Base => '$start',
-            ByteOrder => 'BigEndian',
-        },
+            ByteOrder => 'Unknown', # K-70 is little-endian, K-x is big-endian
+        },
+    },
+    mknt => { # (Q-S1)
+        Name => 'MakerNotes',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Pentax::Main',
+            Start => 10,
+            Base => '$start',
+            ByteOrder => 'Unknown',
+        },
+    },
+);
+
+# Pentax metadata in S1 AVI maker notes (PH)
+%Image::ExifTool::Pentax::S1 = (
+    NOTES => 'Tags extracted from the maker notes of AVI videos from the Optio S1.',
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x0000 => { #5
+        Name => 'MakerNoteVersion',
+        Writable => 'undef',
+        Count => 4,
     },
 );
@@ -4338,5 +5831,246 @@
     0x0c => {
         Name => 'Model',
+        Description => 'Camera Model Name',
         Format => 'string[32]',
+    },
+);
+
+# PreviewImage information found in PXTH atom of K-01 MOV videos
+%Image::ExifTool::Pentax::PXTH = (
+    NOTES => 'Tags found in the PXTH atom of MOV videos from the K-01.',
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x00 => {
+        Name => 'PreviewImageLength',
+        Format => 'int32u',
+    },
+    0x04 => {
+        Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$val{0}]',
+        Notes => '640-pixel-wide JPEG preview', # (360 pixels high, may depend on aspect ratio)
+        RawConv => '$self->ValidateImage(\$val,$tag)',
+    },
+);
+
+# information in PENT atom of MOV videos from the Optio WG-2 GPS
+%Image::ExifTool::Pentax::PENT = (
+    NOTES => 'Tags found in the PENT atom of MOV videos from the Optio WG-2 GPS.',
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'Make',
+        Format => 'string[24]',
+    },
+    0x1a => {
+        Name => 'Model',
+        Description => 'Camera Model Name',
+        Format => 'string[24]',
+    },
+    0x38 => { #(NC)
+        Name => 'ExposureTime',
+        Format => 'int32u',
+        ValueConv => '$val ? 10 / $val : 0',
+        PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
+    },
+    0x3c => {
+        Name => 'FNumber',
+        Format => 'rational64u',
+        PrintConv => 'sprintf("%.1f",$val)',
+    },
+    0x44 => { #(NC)
+        Name => 'ExposureCompensation',
+        Format => 'rational64s',
+        PrintConv => '$val ? sprintf("%+.1f", $val) : 0',
+    },
+    0x54 => { #(NC)
+        Name => 'FocalLength',
+        Format => 'int32u',
+        PrintConv => '"$val mm"',
+    },
+    0x71 => {
+        Name => 'DateTime1',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0x8b => {
+        Name => 'DateTime2',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0xa7 => { #(NC)
+        Name => 'ISO',
+        Format => 'int32u',
+    },
+    0xc7 => {
+        Name => 'GPSVersionID',
+        Format => 'undef[8]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        DataMember => 'GPSVersionID',
+        RawConv => '$$self{GPSVersionID} = ($val=~s/GPS_// ? join(" ",unpack("C*",$val)) : undef)',
+        PrintConv => '$val =~ tr/ /./; $val',
+    },
+    0xcf => {
+        Name => 'GPSLatitudeRef',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[2]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            N => 'North',
+            S => 'South',
+        },
+    },
+    0xd1 => {
+        Name => 'GPSLatitude',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'rational64u[3]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        ValueConv    => 'Image::ExifTool::GPS::ToDegrees($val)',
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0xe9 => {
+        Name => 'GPSLongitudeRef',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[2]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            E => 'East',
+            W => 'West',
+        },
+    },
+    0xeb => {
+        Name => 'GPSLongitude',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'rational64u[3]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        ValueConv    => 'Image::ExifTool::GPS::ToDegrees($val)',
+        PrintConv    => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0x103 => {
+        Name => 'GPSAltitudeRef',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'int8u',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            0 => 'Above Sea Level',
+            1 => 'Below Sea Level',
+        },
+    },
+    0x104 => {
+        Name => 'GPSAltitude',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'rational64u',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => '$val =~ /^(inf|undef)$/ ? $val : "$val m"',
+    },
+    0x11c => {
+        Name => 'GPSTimeStamp',
+        Condition => '$$self{GPSVersionID}',
+        Groups => { 1 => 'GPS', 2 => 'Time' },
+        Format => 'rational64u[3]',
+        ValueConv => 'Image::ExifTool::GPS::ConvertTimeStamp($val)',
+        PrintConv => 'Image::ExifTool::GPS::PrintTimeStamp($val)',
+    },
+    0x134 => {
+        Name => 'GPSSatellites',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[3]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+    },
+    0x137 => {
+        Name => 'GPSStatus',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[2]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            A => 'Measurement Active',
+            V => 'Measurement Void',
+        },
+    },
+    0x139 => {
+        Name => 'GPSMeasureMode',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[2]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+        PrintConv => {
+            2 => '2-Dimensional Measurement',
+            3 => '3-Dimensional Measurement',
+        },
+    },
+    0x13b => {
+        Name => 'GPSMapDatum',
+        Condition => '$$self{GPSVersionID}',
+        Format => 'string[7]',
+        Groups => { 1 => 'GPS', 2 => 'Location' },
+    },
+    0x142 => {
+        Name => 'GPSDateStamp',
+        Condition => '$$self{GPSVersionID}',
+        Groups => { 1 => 'GPS', 2 => 'Time' },
+        Format => 'string[11]',
+        ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
+    },
+    0x173 => { #(NC)
+        Name => 'AudioCodecID',
+        Format => 'string[4]',
+    },
+    0x7d3 => {
+        Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$size-0x7d3]',
+        Notes => '640x480 JPEG preview image', # (black borders pad to 480 pixels high)
+        RawConv => '$self->ValidateImage(\$val,$tag)',
+    },
+);
+
+# tags in Pentax Optio RZ18 AVI videos (ref PH)
+# (very similar to Olympus::AVI tags)
+%Image::ExifTool::Pentax::Junk2 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    NOTES => 'This information is found in AVI videos from the Optio RZ18.',
+    0x12 => {
+        Name => 'Make',
+        Format => 'string[24]',
+    },
+    0x2c => {
+        Name => 'Model',
+        Description => 'Camera Model Name',
+        Format => 'string[24]',
+    },
+    0x5e => {
+        Name => 'FNumber',
+        Format => 'rational64u',
+        PrintConv => 'sprintf("%.1f",$val)',
+    },
+    0x83 => {
+        Name => 'DateTime1',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0x9d => {
+        Name => 'DateTime2',
+        Format => 'string[24]',
+        Groups => { 2 => 'Time' },
+    },
+    0x12b => {
+        Name => 'ThumbnailWidth',
+        Format => 'int16u',
+    },
+    0x12d => {
+        Name => 'ThumbnailHeight',
+        Format => 'int16u',
+    },
+    0x12f => {
+        Name => 'ThumbnailLength',
+        Format => 'int32u',
+    },
+    0x133 => {
+        Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
+        Format => 'undef[$val{0x12f}]',
+        Notes => '160x120 JPEG thumbnail image',
+        RawConv => '$self->ValidateImage(\$val,$tag)',
     },
 );
@@ -4409,7 +6143,36 @@
 
 #------------------------------------------------------------------------------
+# Decode AF bit mask (ref 29)
+# Inputs: 0) raw binary value, 1) number of AF points, 2) number of bits per AF point,
+#         3) bit mask, 4) bit value (undef for any bit set)
+sub DecodeAFPoints($$$$;$)
+{
+    my ($val, $num, $bits, $mask, $bitVal) = @_;
+    my @bytes = split ' ', $val;
+    my $i = 1;  # (starts at AF point number 1)
+    my $shift = 8 - $bits;
+    my $byte = shift @bytes;
+    my @bitList;
+    for (;;) {
+        if ($bitVal) {
+            push @bitList, $i if (($byte >> $shift) & $mask) == $bitVal;
+        } else {
+            push @bitList, $i if ($byte >> $shift) & $mask;
+        }
+        last if ++$i > $num;
+        $shift -= $bits;
+        if ($shift < 0) {
+            last unless @bytes;
+            $byte = shift @bytes;
+            $shift += 8;
+        }
+    }
+    return join(',', @bitList);
+}
+
+#------------------------------------------------------------------------------
 # Convert Pentax hex-based EV (modulo 8) to real number
 # Inputs: 0) value to convert
-# ie) 0x00 -> 0
+# eg) 0x00 -> 0
 #     0x03 -> 0.33333
 #     0x04 -> 0.5
@@ -4456,11 +6219,11 @@
 sub CryptShutterCount($$)
 {
-    my ($val, $exifTool) = @_;
+    my ($val, $et) = @_;
     # Pentax Date and Time values are used in the encryption
-    return undef unless $$exifTool{PentaxDate} and $$exifTool{PentaxTime} and
-        length($$exifTool{PentaxDate})==4 and length($$exifTool{PentaxTime})>=3;
+    return undef unless $$et{PentaxDate} and $$et{PentaxTime} and
+        length($$et{PentaxDate})==4 and length($$et{PentaxTime})>=3;
     # get Date and Time as integers (after padding Time with a null byte)
-    my $date = unpack('N', $$exifTool{PentaxDate});
-    my $time = unpack('N', $$exifTool{PentaxTime} . "\0");
+    my $date = unpack('N', $$et{PentaxDate});
+    my $time = unpack('N', $$et{PentaxTime} . "\0");
     return $val ^ $date ^ (0xffffffff - $time);
 }
@@ -4488,6 +6251,6 @@
 I couldn't find a good source for Pentax maker notes information, but I've
 managed to discover a fair bit of information by analyzing sample images
-downloaded from the internet, and through tests with my own Optio WP,
-K10D, and K-5, and with help provided by other ExifTool users (see
+downloaded from the internet, and through tests with my own Optio S, Optio
+WP, K10D, K-01 and K-5, and with help provided by other ExifTool users (see
 L</ACKNOWLEDGEMENTS>).
 
@@ -4521,13 +6284,13 @@
 =head1 ACKNOWLEDGEMENTS
 
-Thanks to Wayne Smith, John Francis, Douglas O'Brien Cvetan Ivanov, Jens
-Duttke and Dave Nicholson for help figuring out some Pentax tags, Ger
-Vermeulen and Niels Kristian Bech Jensen for contributing print conversion
-values for some tags, and everyone who helped contribute to the LensType
-values.
+Thanks to Wayne Smith, John Francis, Douglas O'Brien, Cvetan Ivanov, Jens
+Duttke, Dave Nicholson, Iliah Borg, Klaus Homeister, Louis Granboulan and
+Andras Salamon for help figuring out some Pentax tags, Ger Vermeulen and
+Niels Kristian Bech Jensen for contributing print conversion values for some
+tags, and everyone who helped contribute to the LensType values.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
